@import "./variables.less";

@actorNameHeight: 50px;

.ACE.sheet.actor {

  /* ----------------------------------------- */
  /*  Shared Styles                            */
  /* ----------------------------------------- */

  // Attribute Configuration
  .config-button {
    color: @colorOlive;
    right: -6px;
    top: -3px;
    font-size: 10px;
    font-weight: normal;
  }

  /* ----------------------------------------- */
  /*  Sheet Header                             */
  /* ----------------------------------------- */

  .sheet-header {
    .font-heading-medium();

    // Portrait Artwork
    img.profile {
      flex: 0 0 160px;
      max-width: 160px;
      height: 160px;
    }

    // Character Name
    h1.charname {
      flex: 1;
      padding: 5px;

      input {
        .font-heading-medium();
        font-variant-caps: small-caps;
        font-size: @actorNameHeight - 12px - 8px;
        padding: 5px 0 0 5px;
        width: 100%;
      }
    }

    // Character UPP
    .header-upp {
      flex: 0 0 150px;
      margin-right: 3px;
      height: @actorNameHeight;
      justify-content: flex-end;
      text-align: right;
    }

    // Character Summary
    .summary {
      height: 30px;
      font-size: 18px;

      li {

        input {
          display: block;
          height: 24px;
          line-height: 24px;
        }

        select {
          position: relative;
          top: -4px;
        }
      }
    }

    // Primary Attributes
    .attributes {
      flex: 0 0 100%;
      margin: 0;

      .attribute {
        border: none;
        border-right: @borderGroove;
        border-radius: 0;
        height: calc(100% - 4px);
        margin: 2px 0 0;

        &:last-child {
          border-right: none;
        }

        .attribute-name {
          position: relative;
        }

        .attribute-value {
          height: 30px;
          line-height: 30px;
        }

        .config-button {
          position: absolute;
          display: none;
        }

        &:hover .config-button {
          display: block;
        }

        // Temporary HP
        input.temphp {
          width: 48%;
        }

        // Attribution Tooltip
        .property-attribution {
          .font-body-medium();
          min-width: 150px;
          top: 50px;
          font-size: 14px;
          line-height: 1rem;
        }
      }
    }
  }

  /* ----------------------------------------- */
  /*  General Styles                           */
  /* ----------------------------------------- */

  // Box Headers
  h4.box-title {
    .font-heading-medium();
    border-bottom: 1px solid @colorFaint;
    color: @colorOlive;
    font-variant-caps: small-caps;
    height: 16px;
    line-height: 14px;
    margin: 2px 8px 1px;
    white-space: nowrap;
  }

  /* ----------------------------------------- */
  /*  Attributes                               */
  /* ----------------------------------------- */

  .tab.attributes {
    overflow: hidden;
  }

  ul.attributes {
    border-left: @borderGroove;
    border-top: @borderGroove;
    flex: 0 0 60px;
    list-style: none;
    margin: 0;
    padding: 0;

    li.attribute {
      border: @borderGroove;
      border-radius: @borderRadius;
      height: calc(100% - 6px);
      margin: 2px 0;
      padding: 0;
      text-align: center;

      &:last-child {
        margin: 0;
      }

      .attribute-value {
        .font-heading-bold();
        display: flex;
        justify-content: center;
        align-items: center;
        height: 28px;
        line-height: 28px;

        >* {
          font-weight: 400;
          font-size: 24px;
          padding: 4px 0 0;
        }

        &.multiple input {
          flex: 1 1 30%;
          padding: 4px 0 0;
        }
      }

      .attribute-footer {
        .font-heading-medium();
        flex: 0 0 18px;
        margin-top: -1px;
        line-height: 18px;
        font-size: 12px;
        white-space: nowrap
      }
    }
  }

  .attributable {
    position: relative;

    &:hover .tooltip {
      display: block;
    }
  }

  /* ----------------------------------------- */
  /*  Characteristic Scores                           */
  /* ----------------------------------------- */

  .characteristic-scores {
    .font-heading-bold();
    flex: 0 0 100px;
    height: 404px;
    list-style: none;
    margin: 0 5px 0;
    padding: 1px 0 2px;
    font-variant-caps: small-caps;
    border: @borderGroove;
    border-radius: @borderRadius;

    .characteristic {
      height: 65px;
      text-align: center;
      border-bottom: @borderGroove;
      position: relative;

      &:last-child {
        border-bottom: none;
        margin-bottom: -3px;
      }

      input.characteristic-score {
        .font-heading-medium();
        height: 40px;
        width: 36px;
        margin: 0 auto;
        line-height: 32px;
        font-size: 28px;
        padding-top: 6px;
      }

      .config-button {
        right: 3px;
        top: 2px;
        position: absolute;
        display: none;
      }

      &:hover .config-button {
        display: block;
      }

      .characteristic-modifiers {
        .font-heading-medium();
        height: 24px;
        // margin: -8px 0 0;

        span.characteristic-mod,
        span.characteristic-current {
          color: @colorTan;
          flex: 0 0 20px;
          height: 20px;
          line-height: 22px;
          font-size: 16px;
          text-align: right;
          padding: 0 16px 0 0;
        }

        span.characteristic-mod {
          border-left: @borderGroove;
        }

        span.characteristic-current {
          border-left: @borderGroove;
          border-top: @borderGroove;
        }
      }
    }
  }

  // Proficiency Toggle Buttons
  .proficiency-toggle {
    color: @colorBeige;
    font-size: 12px;
  }

  .proficient .proficiency-toggle {
    color: @colorOlive;
  }

  .locked .proficiency-toggle {
    color: @colorBeige;
    text-shadow: none;
    cursor: default;
  }

  /* ----------------------------------------- */
  /*  Skills                                   */
  /* ----------------------------------------- */

  ul.skills-list {
    flex: 0 0 180px;
    height: 404px;
    list-style: none;
    margin: 0 5px 0;
    padding: 1px 0 2px;
    border: @borderGroove;
    border-radius: @borderRadius;
    position: relative;

    h4 {
      text-align: center;
    }

    .config-button {
      right: 4px;
      top: 4px;
      position: absolute;
      display: none;
    }

    &:hover .config-button {
      display: block;
    }

    li.skill {
      height: 24px;
      padding: 2px 2px;
      cursor: pointer;

      &.rollable:hover .skill-name .skill-image {
        background: url("icons/dice.svg") no-repeat !important;
        border: 0;
        filter: invert(0.5);
      }

      &.rollable .skill-name .skill-image:hover {
        background: url("icons/dice.svg") no-repeat !important;
        border: 0;
        filter: invert(0);
      }

      &:nth-child(even) {
        background: rgba(0, 0, 0, 0.05);
      }

      .skill-name {
        padding: 2px 0 0;

        .skill-image {
          background-color: @colorFaint;
          background-size: 18px;
          border: @borderSolid;
          height: 20px;
          max-width: 20px;
          width: 20px;
        }
      }

      h4 {
        margin: 0;
        font-size: 11px;
        line-height: 18px;
      }

      .skill-proficiency {
        flex: 0 0 16px;
        line-height: 18px;

        img {
          background-color: gray;
        }
      }

      .skill-name-controls {
        position: relative;
      }

      .skill-characteristic {
        flex: 0 0 26px;
        text-transform: capitalize;
      }

      .skill-mod {
        flex: 0 0 20px;
        padding: 3px 0 0;
      }

      .skill-passive {
        color: @colorTan;
        flex: 0 0 26px;
        padding: 3px 0 0;
        text-align: center;
      }
    }
  }

  /* ----------------------------------------- */
  /*  Statuses                                 */
  /* ----------------------------------------- */

  .counters {
    flex: none;
    padding: 5px 0;
    margin: 0;
    border-bottom: @borderGroove;

    .counter {
      height: 20px;
      line-height: 20px;

      h4 {
        flex: auto;
        margin: 0;
        font-size: 13px;
        font-weight: bold;
        color: @colorOlive;
      }

      .counter-value {
        flex: none;
        text-align: right;

        >* {
          display: inline;
        }
      }

      input[type="text"],
      input[type="number"] {
        height: 20px;
        max-width: 20px;
        margin: 0;
        padding: 0;
        text-align: center;
      }

      input[type="checkbox"] {
        position: relative;
        width: 16px;
        height: 16px;
        margin: 0;
        top: 4px;
      }

      span.sep {
        font-size: 12px;
      }
    }
  }

  /* ----------------------------------------- */
  /*  Traits                                   */
  /* ----------------------------------------- */

  .center-pane {
    height: 100%;
    padding: 0 5px 0 3px;
    overflow-y: auto;
    scrollbar-width: thin;
  }

  .traits {

    .form-group,
    .form-group-stacked {
      margin: 0 0 3px 0;
      justify-content: space-between;
    }

    .config-button {
      flex: 1;
    }

    label {
      .font-heading-bold();
      flex: none;
      line-height: 20px;
      margin: 0 10px 0 0;
    }

    select {
      background: @colorFaintFaint;
      max-width: 200px;
    }

    input {
      text-align: right;
    }

    i.fas {
      float: right;
      margin-right: 3px;
      text-align: right;
      color: #999;

      &:hover {
        color: #111;
        text-shadow: 0 0 10px red;
      }
    }

    .inactive {
      color: @colorTan;
    }
  }

  /* ----------------------------------------- */
  /*  Inventory Lists                          */
  /* ----------------------------------------- */

  .tab.features,
  .tab.inventory,
  .tab.spellbook {
    overflow-y: hidden;
  }

  /* Inventory List Filters */
  .inventory-filters {
    margin: 0 8px;
    flex: 0 0 20px;
    justify-content: flex-end;

    .currency {
      flex: 0 0 100%;
      list-style: none;
      margin: 4px 0 8px;
      padding: 0;
      font-size: 12px;

      label {
        flex: 0;
        margin-left: 8px;
        text-align: right;
        line-height: 20px;
        color: @colorTan;
      }

      input[type="text"] {
        flex: 0 0 48px;
        text-align: center;
        margin-left: 8px;
        border-bottom: @borderGroove;
      }
    }
  }

  // Inventory item lists
  .inventory-list {
    padding: 0 5px;

    .item {
      .item-name {
        cursor: pointer;
        margin-left: 2px;

        &.rollable:hover .item-image {
          background: url("icons/dice.svg") no-repeat !important;
          border: 0;
          filter: invert(0.5)
        }

        &.rollable .item-image:hover {
          background: url("icons/dice.svg") no-repeat !important;
          border: 0;
          filter: invert(0)
        }
      }

      // Item uses
      .item-uses input {
        width: 24px;
        text-align: center;
      }

      // Item Dropdown Properties
      .item-properties {
        margin-top: 3px;
      }

      // Charged
      .item-recharge {
        flex: 0 0 80px;
        text-align: right;
        font-size: 11px;
        white-space: nowrap;
      }
    }

    // Inventory Header
    .inventory-header {
      .item-controls a.item-create {
        flex: 0 0 100%;
      }
    }

    // Item Detail Sections
    .item-detail {
      flex: 0 0 70px;
      font-size: 12px;
      text-align: center;
      border-right: 1px solid @colorFaint;
      word-break: break-word;
      white-space: nowrap;
      overflow: hidden;

      &:last-child {
        border-right: none;
      }

      &.item-action {
        flex: 0 0 100px
      }

      &.attunement {
        flex: 0 0 24px
      }
    }

    .item-weight {
      flex: 0 0 60px;
      border-left: 1px solid @colorFaint;
      border-right: 1px solid @colorFaint;
    }

    // Item Control Buttons
    .item-controls {
      flex: 0 0 44px;
    }

    // Item Dropdown Summary
    .item-summary {
      .font-body-regular();
      // border-top: 1px solid @colorFaint;
      color: @colorDark;
      flex: 0 0 100%;
      // margin-top: 2px;
      padding: 0.25em 0.5em;

      p {
        margin: 0;
      }
    }
  }

  /* Encumbrance Bar */
  .encumbrance {
    flex: 0 0 14px;
    background: @colorTan;
    margin: 1px 19px 0 1px;
    border: 1px solid @colorDark;
    border-radius: @borderRadius;
    position: relative;

    .encumbrance-bar {
      position: absolute;
      top: 1px;
      left: 1px;
      background: #0C0;
      height: 10px;
      border: 1px solid #EEE;
      border-radius: @borderRadius - 2px;
    }

    .encumbrance-label {
      height: 14px;
      padding: 2px 2px 0px;
      position: absolute;
      top: 0;
      right: 0;
      font-size: 13px;
      line-height: 12px;
      text-align: right;
      color: #EEE;
      text-shadow: 0 0 5px #000;
    }

    .encumbrance-breakpoint {
      display: block;
      position: absolute;

      &.encumbrance-33 {
        left: 33%
      }

      &.encumbrance-66 {
        left: 66%
      }
    }

    .arrow-up {
      bottom: 0;
      width: 0;
      height: 0;
      border-left: 4px solid transparent;
      border-right: 4px solid transparent;
      border-bottom: 4px solid #666;
    }

    .arrow-down {
      top: 0;
      width: 0;
      height: 0;
      border-left: 4px solid transparent;
      border-right: 4px solid transparent;
      border-top: 4px solid #666;
    }

    &.encumbered {
      .arrow-up {
        border-bottom: 4px solid #000;
      }

      .arrow-down {
        border-top: 4px solid #000;
      }
    }
  }

  /* ----------------------------------------- */
  /*  Spellbook                                */
  /* ----------------------------------------- */

  .spellcasting-characteristic {
    flex: 0 0 240px;
    margin: 0;

    label,
    span {
      flex: none;
    }

    input {
      flex: 0 0 28px;
      text-align: center;
    }

    select {
      margin: 0 5px;
      flex: 0 0 120px;
    }
  }

  .spell-slots,
  .spell-comps {
    flex: none;
    padding: 0 5px;
    font-size: 12px;
    color: @colorTan;
    border-right: 1px solid @colorFaint;
  }

  .spell-slots {
    input {
      display: inline;
      max-width: 20px;
    }

    .sep {
      font-size: 13px;
      font-weight: normal;
    }
  }

  .spellbook .spell-uses {
    padding-right: 5px;
    text-align: right;
    color: @colorTan;
  }

  .spell-school,
  .spell-action,
  .spell-target {
    flex: 0 0 100px;
    font-size: 12px;
    color: @colorTan;
    text-align: center;
    border-right: 1px solid @colorFaint;
  }

  .spell-component {
    line-height: 14px;

    &.C,
    &.R {
      display: inline-block;
      text-align: center;
      padding-top: 1px;
      width: 16px;
      color: @colorFaint;
      background: rgba(0, 0, 0, 0.4);
      border: 1px solid transparent;
      border-radius: @borderRadius + 4px;
    }
  }

  // Empty spellbook controls
  .spellbook-empty .item-controls {
    flex: 1;
  }

  /* ----------------------------------------- */
  /*  Features Tab                             */
  /* ----------------------------------------- */

  // Original class icon
  .features i.original-class {
    color: #4b4a44
  }

  /* ----------------------------------------- */
  /*  TinyMCE                                  */
  /* ----------------------------------------- */

  .editor {
    padding: 0 8px;
  }
}

#actor-flags {
  .window-content {
    overflow-y: hidden;
  }

  form {
    height: 100%;
  }

  .form-body {
    height: calc(100% - 40px);
    padding-right: 8px;
    margin-bottom: 4px;
    overflow-y: auto;
    scrollbar-width: thin;
  }
}